/*
 * TeleStax, Open Source Cloud Communications  Copyright 2012. 
 * and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.mobicents.protocols.ss7.m3ua.impl;

import javolution.util.FastList;

import org.mobicents.protocols.ss7.m3ua.M3UAManagementEventListener;
import org.mobicents.protocols.ss7.m3ua.State;
import org.mobicents.protocols.ss7.m3ua.impl.fsm.FSMState;
import org.mobicents.protocols.ss7.m3ua.impl.fsm.FSMStateEventHandler;

/**
 * 
 * @author amit bhayani
 *
 */
public class AspStateEnterInactive implements FSMStateEventHandler {

	private final AspImpl aspImpl;

	public AspStateEnterInactive(AspImpl aspImpl) {
		this.aspImpl = aspImpl;
	}

	@Override
	public void onEvent(FSMState state) {

		// Call listener and indicate of state change only if not already done
		if (!this.aspImpl.state.getName().equals(State.STATE_INACTIVE)) {
			this.aspImpl.state = AspState.INACTIVE;

			FastList<M3UAManagementEventListener> managementEventListenersTmp = this.aspImpl.aspFactoryImpl.m3UAManagementImpl.managementEventListeners;

			for (FastList.Node<M3UAManagementEventListener> n = managementEventListenersTmp.head(), end = managementEventListenersTmp
					.tail(); (n = n.getNext()) != end;) {
				M3UAManagementEventListener m3uaManagementEventListener = n.getValue();
				m3uaManagementEventListener.onAspInactive(this.aspImpl);
			}
		}
	}
}
